<#macro typeTransfer type>
	<#if "boolean" == type>
System.Boolean<#return>
	<#elseif "integer8" == type>
System.Byte<#return>
	<#elseif "integer16" == type>
System.Int16<#return>
	<#elseif "integer32" == type>
System.Int32<#return>
	<#elseif "integer64" == type>
System.Int64<#return>
	<#elseif "decimal32" == type>
System.Single<#return>
	<#elseif "decimal64" == type>
System.Double<#return>
	<#elseif "string" == type>
System.String<#return>
	<#elseif "date" == type>
System.DateTime<#return>
	<#elseif "object" == type>
System.Object<#return>
	<#elseif "array" == type>
System.Collections.Generic.List<System.Object><#return>
	<#elseif "dictionary" == type>
System.Collections.Generic.Dictionary<System.Object, System.Object><#return>
	<#else>
${type}<#return>
	</#if>
</#macro>
<#macro valueTransfer type value>
	<#if "boolean" == type && "true" == value>
true<#return>
	<#elseif "boolean" == type>
false<#return>
	<#elseif "integer64" == type>
${value}L<#return>
	<#elseif "decimal32" == type>
${value}F<#return>
	<#elseif "date" == type>
new System.DateTime()<#return>
	<#elseif "null" == value>
null<#return>
	<#elseif "string" == type>
"${value}"<#return>
	<#elseif "array" == type && "new" == value>
new System.Collections.Generic.List<System.Object>()<#return>
	<#elseif "dictionary" == type && "new" == value>
new System.Collections.Generic.Dictionary<System.Object, System.Object>()<#return>
	<#else>
${value}<#return>
</#if>
</#macro>
<#if package?? && "" != package>
namespace ${package}
{
</#if>
<#if macros??>
	<#if macros.name?? && "" != macros.name>
		<#if macros.note?? && "" != macros.note>
<#if package?? && "" != package>	</#if>/// <summary>
<#if package?? && "" != package>	</#if>/// ${macros.note}
<#if package?? && "" != package>	</#if>/// </summary>
		</#if>
<#if package?? && "" != package>	</#if>public class ${macros.name}
<#if package?? && "" != package>	</#if>{

		<#assign needGap = false/>
		<#list macros.macros as macro>
			<#if macro.name?? && "" != macro.name && macro.type?? && "" != macro.type && macro.value?? && "" != macro.value>
				<#assign needGap = true/>
				<#if macro.note?? && "" != macro.note>
<#if package?? && "" != package>	</#if>	/// <summary>
<#if package?? && "" != package>	</#if>	/// ${macro.note}
<#if package?? && "" != package>	</#if>	/// </summary>
				</#if>
<#if package?? && "" != package>	</#if>	public const <@typeTransfer type = macro.type/> ${macro.name?upper_case} = <@valueTransfer type = macro.type value = macro.value/>;
			</#if>
		</#list>
		<#list macros.groups as group>
			<#assign gapped = false/>
			<#if group.name?? && "" != group.name && group.type?? && "" != group.type && group.value?? && "" != group.value>
				<#if needGap>

				</#if>
				<#assign needGap = true gapped = true/>
				<#if group.note?? && "" != group.note>
<#if package?? && "" != package>	</#if>	/// <summary>
<#if package?? && "" != package>	</#if>	/// ${group.note}
<#if package?? && "" != package>	</#if>	/// </summary>
				</#if>
<#if package?? && "" != package>	</#if>	public const <@typeTransfer type = group.type/> ${group.name?upper_case} = <@valueTransfer type = group.type value = group.value/>;
			</#if>
			<#list group.macros as macro>
				<#if macro.name?? && "" != macro.name && macro.type?? && "" != macro.type && macro.value?? && "" != macro.value>
					<#if needGap && !gapped>

					</#if>
					<#assign gapped = true/>
					<#if macro.note?? && "" != macro.note>
<#if package?? && "" != package>	</#if>	/// <summary>
<#if package?? && "" != package>	</#if>	/// ${macro.note}
<#if package?? && "" != package>	</#if>	/// </summary>
					</#if>
<#if package?? && "" != package>	</#if>	public const <@typeTransfer type = macro.type/> ${macro.name?upper_case} = <@valueTransfer type = macro.type value = macro.value/>;
				</#if>
			</#list>
		</#list>

<#if package?? && "" != package>	</#if>}
	</#if>
</#if>
<#if package?? && "" != package>
}
</#if>