<#macro typeTransfer type>
	<#if "boolean" == type>
boolean<#return>
	<#elseif "integer8" == type>
byte<#return>
	<#elseif "integer16" == type>
short<#return>
	<#elseif "integer32" == type>
int<#return>
	<#elseif "integer64" == type>
long<#return>
	<#elseif "decimal32" == type>
float<#return>
	<#elseif "decimal64" == type>
double<#return>
	<#elseif "string" == type>
String<#return>
	<#elseif "date" == type>
java.util.Date<#return>
	<#elseif "object" == type>
Object<#return>
	<#elseif "array" == type>
java.util.List<Object><#return>
	<#elseif "dictionary" == type>
java.util.Map<Object, Object><#return>
	<#else>
${type}<#return>
	</#if>
</#macro>
<#macro valueTransfer type value>
	<#if "boolean" == type && "true" == value>
true<#return>
	<#elseif "boolean" == type>
false<#return>
	<#elseif "integer64" == type>
${value}L<#return>
	<#elseif "decimal32" == type>
${value}F<#return>
	<#elseif "null" == value>
null<#return>
	<#elseif "string" == type>
"${value}"<#return>
	<#elseif "date" == type && "new" == value>
new java.util.Date()<#return>
	<#elseif "array" == type && "new" == value>
new java.util.ArrayList<>()<#return>
	<#elseif "dictionary" == type && "new" == value>
new java.util.HashMap<>()<#return>
	<#else>
${value}<#return>
</#if>
</#macro>
<#if package?? && "" != package>
package ${package};

</#if>
<#if object??>
	<#list object.importsJava as import>
import ${import};
		<#if import_index + 1 == object.importsJava?size>

		</#if>
	</#list>
	<#if object.name?? && "" != object.name>
		<#if object.note?? && "" != object.note>
/** ${object.note} */
		</#if>
public class ${object.name}<#if object.extend?? && "" != object.extend> extends ${object.extend}</#if> {

	//============================================================================
	//PROPERTY
	//============================================================================
		<#list object.properties as property>
			<#if property.name?? && "" != property.name>
				<#if property.typeJava??>
					<#if "" != property.typeJava>
						<#if property.valueJava??>
	private ${property.typeJava} ${property.name}<#if "" != property.valueJava> = ${property.valueJava}</#if>;
						<#elseif property.value??>
	private ${property.typeJava} ${property.name}<#if "" != property.value> = ${property.value}</#if>;
						<#else>
	private ${property.typeJava} ${property.name};
						</#if>
					</#if>
				<#elseif property.type?? && "" != property.type>
					<#if property.valueJava??>
	private <@typeTransfer type = property.type/> ${property.name}<#if "" != property.valueJava> = <@valueTransfer type = property.type value=property.valueJava/></#if>;
					<#elseif property.value??>
	private <@typeTransfer type = property.type/> ${property.name}<#if "" != property.value> = <@valueTransfer type = property.type value=property.value/></#if>;
					<#else>
	private <@typeTransfer type = property.type/> ${property.name};
					</#if>
				</#if>
			</#if>
		</#list>
	//============================================================================
	//CONSTRUCTOR
	//============================================================================
	public ${object.name}() {}
	//============================================================================
	//GETTER_SETTER
	//============================================================================
		<#assign needGap = false/>
		<#list object.properties as property>
			<#if property.name?? && "" != property.name>
				<#if property.typeJava??>
					<#if "" != property.typeJava>
						<#if needGap>

						</#if>
						<#assign needGap = true/>
						<#if property.note?? && "" != property.note>
	/** ${property.note} */
						</#if>
	public ${property.typeJava} get${property.name?cap_first}() { return ${property.name}; }
					</#if>
				<#elseif property.type?? && "" != property.type>
					<#if needGap>

					</#if>
					<#assign needGap = true/>
					<#if property.note?? && "" != property.note>
	/** ${property.note} */
					</#if>
	public <@typeTransfer type = property.type/> get${property.name?cap_first}() { return ${property.name}; }
				</#if>
				<#if property.typeJava??>
					<#if "" != property.typeJava>
						<#if property.note?? && "" != property.note>
	/** ${property.note} */
						</#if>
	public void set${property.name?cap_first}(${property.typeJava} value) { this.${property.name} = value; }
					</#if>
				<#elseif property.type?? && "" != property.type>
					<#if property.note?? && "" != property.note>
	/** ${property.note} */
					</#if>
	public void set${property.name?cap_first}(<@typeTransfer type = property.type/> value) { this.${property.name} = value; }
				</#if>
			</#if>
		</#list>

}
	</#if>
</#if>